org.openmuc.josistack

## Class ClientAcseSap

- java.lang.Object
- - org.openmuc.josistack.ClientAcseSap

    public final class ClientAcseSap
    extends java.lang.Object

This class implements the Service Access Point (SAP) for the Application Control Service Element (ACSE) protocol as defined by ISO 8650 or ITU X.217/X.227. The ACSE provides services for establishing and releasing application-associations. The class also realizes the lower ISO Presentation Layer as defined by ISO 8823/ITU X226 and the ISO Session Layer as defined by 8327/ITU X.225.

### Field Summary

Fields
`byte[]` `pSelLocal`
`byte[]` `pSelRemote`
`byte[]` `sSelLocal`
`byte[]` `sSelRemote`
`org.openmuc.jositransport.ClientTSap` `tSap`

### Constructor Summary

Constructors
Constructor and Description
`ClientAcseSap()` Use this constructor to create a client ACSE Service Access Point (SAP) that will start connections to remote ACSE SAPs.
`ClientAcseSap(javax.net.SocketFactory socketFactory)`

### Method Summary

All Methods Instance Methods Concrete Methods
`AcseAssociation` `associate(java.net.InetAddress address, int port, java.net.InetAddress localAddr, int localPort, java.lang.String authenticationParameter, java.nio.ByteBuffer apdu)` Associate to a remote ServerAcseSAP that is listening at the destination address.
`void` `setAeQualifierCalled(int qualifier)`
`void` `setAeQualifierCalling(int qualifier)`
`void` `setApTitleCalled(int[] title)`
`void` `setApTitleCalling(int[] title)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### tSap

    public org.openmuc.jositransport.ClientTSap tSap

#### pSelRemote

    public byte[] pSelRemote

#### pSelLocal

    public byte[] pSelLocal

#### sSelRemote

    public byte[] sSelRemote

#### sSelLocal

    public byte[] sSelLocal

### Constructor Detail

#### ClientAcseSap

    public ClientAcseSap()

Use this constructor to create a client ACSE Service Access Point (SAP) that will start connections to remote ACSE SAPs. Once constructed the AcseSAP contains a public TSAP that can be accessed to set its configuration.

#### ClientAcseSap

    public ClientAcseSap(javax.net.SocketFactory socketFactory)

### Method Detail

#### setApTitleCalled

    public void setApTitleCalled(int[] title)

#### setApTitleCalling

    public void setApTitleCalling(int[] title)

#### setAeQualifierCalled

    public void setAeQualifierCalled(int qualifier)

#### setAeQualifierCalling

    public void setAeQualifierCalling(int qualifier)

#### associate

    public AcseAssociation associate(java.net.InetAddress address,
                                     int port,
                                     java.net.InetAddress localAddr,
                                     int localPort,
                                     java.lang.String authenticationParameter,
                                     java.nio.ByteBuffer apdu)
                              throws java.io.IOException

Associate to a remote ServerAcseSAP that is listening at the destination address.

Parameters:
  `address` - remote InetAddress
  `port` - remote port
  `localAddr` - local InetAddress
  `localPort` - local port
  `authenticationParameter` - an authentication parameter
  `apdu` - the payload to send with the association request
Returns:
  the association object
Throws:
  `java.io.IOException` - if an error occurs connecting